/*
 * Copyright (c) 2000 Blue Mug, Inc.  All Rights Reserved.
 */

#ifndef _SHOEHORN_UTIL_H
#define _SHOEHORN_UTIL_H

#ifdef MSW
#include <windows.h>
typedef long ssize_t;
#endif

#ifndef min
#define min(a,b)	((a)<(b) ? (a) : (b))
#endif

extern void perror_exit(const char *errstr);
extern void print_size(unsigned start, unsigned size);
extern void read_file(const char *filename, unsigned char **buf,
		      unsigned *size);

extern void *xmalloc(size_t size);

#ifndef MSW
extern void xclose(int fd);
extern ssize_t xread(int fd, void *buf, size_t count);
extern ssize_t xaread(int fd, void *buf, size_t count);
extern ssize_t xwrite(int fd, const void *buf, size_t count);
extern ssize_t xawrite(int fd, const void *buf, size_t count);
#else
extern void xclose(HANDLE fd);
extern ssize_t xread(HANDLE fd, void *buf, size_t count);
extern ssize_t xaread(HANDLE fd, void *buf, size_t count);
extern ssize_t xwrite(HANDLE fd, const void *buf, size_t count);
extern ssize_t xawrite(HANDLE fd, const void *buf, size_t count);
#endif

#endif /* _SHOEHORN_UTIL_H */
